"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }// src/common/data/xrx.ts
var RX_WHITESPACE = /\\\s|\s+|#[^\n]*\n?/gm;
var RX_REAL_GROUPS = /\(\?P?<(\w[\w\d_]+)>|\((?!\?(:|\!|=|<=|<\!))/gm;
var RX_LOOK_BEHIND = /^((?:\(\?[\w$]+\))?)\(\?<([=!])([\s\S]*?)\)/gm;
function regExpString(rx) {
  return typeof rx === "string" ? rx : rx.source || "";
}
function regExpEscape(str) {
  return str.replace(/[-\[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
}
var XRX = class {
  constructor(pattern, flags) {
    this.namedGroups = {};
    this.names = [];
    let _flags = _nullishCoalesce(flags, () => ( ""));
    let _rx;
    if (pattern instanceof RegExp) {
      if (flags == null)
        _flags = pattern.flags;
      _rx = pattern.source;
    } else {
      _rx = pattern;
    }
    const extended = _flags && _flags.includes("x");
    if (extended) {
      _flags = _flags.replace("x", "");
      _rx = _rx.replace(RX_WHITESPACE, (r) => {
        return r[0] === "\\" ? r : "";
      });
    }
    if (!(pattern instanceof RegExp)) {
      let index = 0;
      _rx = _rx.replace(RX_REAL_GROUPS, (str, name) => {
        index += 1;
        if (name) {
          if (name !== "index" && name !== "length" && !this.namedGroups[name])
            this.namedGroups[name] = index;
          return "(";
        }
        return str;
      });
      this.names = Object.keys(this.namedGroups);
    }
    _rx = regExpString(_rx);
    RX_LOOK_BEHIND.lastIndex = 0;
    const parts = RX_LOOK_BEHIND.exec(_rx);
    if (parts) {
      this.lookBehind = {
        rx: new RegExp(`${parts[3]}$(?!\\s)`),
        expect: parts ? parts[2] === "=" : !parts
      };
      _rx = _rx.substr(parts[0].length);
    }
    this.rx = new RegExp(_rx, _flags);
  }
  // flagsString() {
  //     let hash = this.rx.toString() + '/'
  //     if (this.rx.global) {
  //         hash += 'g'
  //     }
  //     if (this.rx.multiline) {
  //         hash += 'm'
  //     }
  //     if (this.rx.ignoreCase) {
  //         hash += 'i'
  //     }
  //     if (this.rx.unicode) {
  //         hash += 'u'
  //     }
  //     if (this.rx.sticky) {
  //         hash += 'y'
  //     }
  // }
  get lastIndex() {
    return this.rx.lastIndex;
  }
  set lastIndex(index) {
    this.rx.lastIndex = index;
  }
  _handleMatch(m) {
    if (this.lookBehind) {
      const leftContext = m.input.slice(0, m.index);
      if (this.lookBehind.expect !== this.lookBehind.rx.test(leftContext))
        return null;
    }
    for (const name of this.names)
      m[name] = m[this.namedGroups[name]];
    return m;
  }
  exec(str) {
    let m;
    while (m = this.rx.exec(str)) {
      if (this.rx.lastIndex === m.index)
        this.rx.lastIndex++;
      m = this._handleMatch(m);
      if (m != null)
        return m;
    }
  }
  execAll(str) {
    const matches = [];
    let m;
    this.rx.lastIndex = 0;
    while (m = this.exec(str))
      matches.push(m);
    this.rx.lastIndex = 0;
    return matches;
  }
  replace(str, replacement) {
    const fn = typeof replacement === "function" ? replacement : () => replacement;
    return str.replace(this.rx, (m) => {
      return fn(m);
    });
  }
};





exports.regExpString = regExpString; exports.regExpEscape = regExpEscape; exports.XRX = XRX;
//# sourceMappingURL=chunk-DRTH56G4.cjs.map