"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }

var _chunkTZOPYZVRcjs = require('./chunk-TZOPYZVR.cjs');


var _chunkTBWBBQXTcjs = require('./chunk-TBWBBQXT.cjs');

// src/node/files.ts
var _fs = require('fs');
var _path = require('path');
var _process = require('process'); var _process2 = _interopRequireDefault(_process);
function getStat(path) {
  try {
    return _fs.statSync.call(void 0, path);
  } catch (err) {
  }
}
function getFingerprint(path) {
  const { mtimeMs, size } = _nullishCoalesce(getStat(path), () => ( {}));
  return `${path}|${mtimeMs}|${size}`;
}
function walkSync(rootFolder, subFolder = "", ignoreHidden = true) {
  let resultPaths = [];
  const paths = _fs.readdirSync.call(void 0, _path.resolve.call(void 0, rootFolder, subFolder));
  if (paths != null && paths.length > 0) {
    for (let file of paths) {
      file = _path.join.call(void 0, subFolder, file);
      if (ignoreHidden && _chunkTBWBBQXTcjs.isHiddenPath.call(void 0, file))
        continue;
      const realFile = _path.join.call(void 0, rootFolder, file);
      const stat = getStat(realFile);
      if (stat && stat.isDirectory())
        resultPaths = resultPaths.concat(walkSync(rootFolder, file) || []);
      else
        resultPaths.push(file);
    }
  }
  return resultPaths;
}
function files(opt = {}) {
  let {
    pattern,
    filter,
    basePath = _process2.default.cwd(),
    ignoreHidden = false
  } = opt;
  let paths = walkSync(basePath, "", ignoreHidden);
  paths = paths.filter(
    (path) => !(ignoreHidden && (path.startsWith(".") || path.includes("/.")))
  );
  if (pattern) {
    if (typeof pattern === "string")
      pattern = _chunkTZOPYZVRcjs.globToRegExp.call(void 0, pattern);
    if (pattern instanceof RegExp) {
      const rx = pattern;
      rx.lastIndex = 0;
      paths = paths.filter((path) => rx.test(path));
    }
  }
  if (filter)
    paths = paths.filter(filter);
  return paths;
}






exports.getStat = getStat; exports.getFingerprint = getFingerprint; exports.walkSync = walkSync; exports.files = files;
//# sourceMappingURL=chunk-GQSQ3BA4.cjs.map