import {
  jsonStringifySafe
} from "./chunk-VWBTJP5F.js";

// src/browser/localstorage.ts
var LocalStorage = class {
  constructor(opt) {
    this.pretty = false;
    this.name = opt.name ?? "zeed";
    this.prefix = `${opt.name}$`;
    this.objectToString = opt.objectToString ?? ((data) => {
      return this.pretty ? jsonStringifySafe(data, null, 2) : jsonStringifySafe(data);
    });
    this.objectFromString = opt.objectFromString ?? ((data) => {
      try {
        return JSON.parse(data);
      } catch (err) {
      }
    });
  }
  setItem(key, value) {
    const data = this.objectToString(value);
    localStorage.setItem(`${this.prefix}${key}`, data);
  }
  getItem(key) {
    const value = localStorage.getItem(`${this.prefix}${key}`);
    if (value != null)
      return this.objectFromString(value);
  }
  removeItem(key) {
    localStorage.removeItem(`${this.prefix}${key}`);
  }
  clear() {
    Object.keys(localStorage).filter((key) => key.startsWith(this.prefix)).forEach((key) => {
      localStorage.removeItem(key);
    });
  }
  allKeys() {
    const prefixLength = this.prefix.length;
    return Object.keys(localStorage).filter((key) => key.startsWith(this.prefix)).map((key) => key.substr(prefixLength));
  }
};

export {
  LocalStorage
};
//# sourceMappingURL=chunk-TNVQTB3S.js.map