"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunkN5KTMDVOcjs = require('./chunk-N5KTMDVO.cjs');

// src/common/msg/rpc.ts
var rpcCounter = 1;
var defaultSerialize = (i) => i;
var defaultDeserialize = defaultSerialize;
function setupRPCBasic(options, functions, eventNames = []) {
  const {
    log,
    post,
    on,
    serialize = defaultSerialize,
    deserialize = defaultDeserialize,
    timeout = 6e4,
    onError,
    onTimeoutError,
    onlyEvents = false,
    exceptions = true,
    stringHashPool
  } = options;
  if (stringHashPool) {
    Object.keys(functions).forEach(stringHashPool.hash);
  }
  function checkEventNames(eventNames2) {
  }
  checkEventNames(eventNames);
  function registerFunctions(additionalFunctions) {
    Object.assign(functions, _nullishCoalesce(additionalFunctions, () => ( {})));
    if (stringHashPool)
      Object.keys(additionalFunctions).forEach(stringHashPool.hash);
  }
  function registerEventNames(additionalEventNames) {
    checkEventNames(additionalEventNames);
    eventNames.push(...additionalEventNames);
  }
  const rpcPromiseMap = /* @__PURE__ */ new Map();
  on(async (data) => {
    try {
      const msg = await deserialize(data);
      const mode = _optionalChain([msg, 'optionalAccess', _2 => _2[0]]);
      const id = mode === 2 /* event */ ? 0 : _optionalChain([msg, 'optionalAccess', _3 => _3[1]]);
      const [method, ...args] = msg.slice(mode === 2 /* event */ ? 1 : 2);
      const methodName = _nullishCoalesce(_optionalChain([stringHashPool, 'optionalAccess', _4 => _4.stringForHash, 'call', _5 => _5(method)]), () => ( method));
      if (mode === 1 /* request */ || mode === 2 /* event */) {
        let result, error;
        if (method != null) {
          try {
            const fn = functions[methodName];
            result = await fn(...args);
          } catch (e) {
            error = String(e);
          }
        } else {
          error = "Method implementation missing";
        }
        if (error) {
          _optionalChain([log, 'optionalAccess', _6 => _6.warn, 'call', _7 => _7("error", msg, error)]);
          _optionalChain([onError, 'optionalCall', _8 => _8(error, _nullishCoalesce(method, () => ( "")), args)]);
        }
        if (id > 0) {
          const data2 = await serialize(error ? [4 /* reject */, id, error] : [3 /* resolve */, id, result]);
          await post(data2);
        }
      } else if (id) {
        const promise = rpcPromiseMap.get(id);
        if (promise != null) {
          clearTimeout(promise.timeoutId);
          if (mode === 4 /* reject */ && exceptions === true)
            promise.reject(method);
          else
            promise.resolve(method);
        }
        rpcPromiseMap.delete(id);
      }
    } catch (err) {
      _optionalChain([log, 'optionalAccess', _9 => _9.warn, 'call', _10 => _10("Error on handling RPC data. Invalid?", err, data)]);
    }
  });
  const proxyHandler = {
    get(_, methodName) {
      const method = _nullishCoalesce(_optionalChain([stringHashPool, 'optionalAccess', _11 => _11.hash, 'call', _12 => _12(methodName)]), () => ( methodName));
      const sendEvent = async (...args) => await post(await serialize([2 /* event */, method, ...args]));
      if (onlyEvents || eventNames.includes(methodName)) {
        sendEvent.asEvent = sendEvent;
        return sendEvent;
      }
      const sendCall = async (...args) => {
        const [promise, resolve, reject] = _chunkN5KTMDVOcjs.createPromise.call(void 0, );
        const id = rpcCounter++;
        let timeoutId;
        if (timeout >= 0) {
          timeoutId = _optionalChain([setTimeout, 'call', _13 => _13(() => {
            try {
              _optionalChain([onTimeoutError, 'optionalCall', _14 => _14(methodName, args)]);
              throw new Error(`rpc timeout on calling "${methodName}"`);
            } catch (e) {
              if (exceptions === true)
                reject(e);
              else
                resolve(void 0);
            }
            rpcPromiseMap.delete(id);
          }, timeout), 'access', _15 => _15.unref, 'optionalCall', _16 => _16()]);
        }
        rpcPromiseMap.set(id, { resolve, reject, timeoutId });
        const data = await serialize([1 /* request */, id, method, ...args]);
        await post(data);
        return promise;
      };
      sendCall.asEvent = sendEvent;
      return sendCall;
    }
  };
  return {
    post,
    serialize,
    rpcPromiseMap,
    proxyHandler,
    registerFunctions,
    registerEventNames
  };
}
function useRPC(functions, options) {
  const { eventNames = [] } = options;
  const { proxyHandler } = setupRPCBasic(options, functions, eventNames);
  return new Proxy({}, proxyHandler);
}
function useRPCHub(options) {
  const eventNames = [];
  const functions = {};
  const {
    proxyHandler,
    registerFunctions,
    registerEventNames
  } = setupRPCBasic(options, functions, eventNames);
  function createRPCProxy() {
    return new Proxy({}, proxyHandler);
  }
  return function(additionalFunctions, additionalEventNames = []) {
    registerFunctions(_nullishCoalesce(additionalFunctions, () => ( {})));
    registerEventNames(additionalEventNames);
    return createRPCProxy();
  };
}




exports.useRPC = useRPC; exports.useRPCHub = useRPCHub;
//# sourceMappingURL=chunk-TVG2N27I.cjs.map