"use strict";Object.defineProperty(exports, "__esModule", {value: true});




var _chunk52BL3727cjs = require('./chunk-52BL3727.cjs');

// src/common/data/deep.ts
function deepEqual(a, b, hash = /* @__PURE__ */ new WeakSet()) {
  if (a === b)
    return true;
  if (hash.has(b)) {
    return false;
  }
  if (!_chunk52BL3727cjs.isPrimitive.call(void 0, b))
    hash.add(b);
  if (!(a instanceof Object) || !(b instanceof Object))
    return false;
  if (a.constructor !== b.constructor)
    return false;
  if (a.length !== b.length)
    return false;
  for (const p in a) {
    if (!a.hasOwnProperty(p))
      continue;
    if (!b.hasOwnProperty(p))
      return false;
    const aa = a[p];
    const bb = b[p];
    if (!deepEqual(aa, bb, hash))
      return false;
  }
  for (const p in b) {
    if (b.hasOwnProperty(p) && !a.hasOwnProperty(p))
      return false;
  }
  return true;
}
function deepStripUndefinedInPlace(a, hash = /* @__PURE__ */ new WeakSet()) {
  if (hash.has(a))
    return "[Circular ~]";
  if (!_chunk52BL3727cjs.isPrimitive.call(void 0, a))
    hash.add(a);
  if (_chunk52BL3727cjs.isRecord.call(void 0, a)) {
    for (const p in a) {
      if (!a.hasOwnProperty(p))
        continue;
      if (a[p] === void 0) {
        delete a[p];
        continue;
      }
      deepStripUndefinedInPlace(a[p], hash);
    }
  } else if (_chunk52BL3727cjs.isArray.call(void 0, a)) {
    for (let i = a.length - 1; i >= 0; i--) {
      if (a[i] === void 0)
        a.splice(i, 1);
    }
  }
  return a;
}
function deepMerge(target, ...sources) {
  for (const source of sources) {
    if (!_chunk52BL3727cjs.isObject.call(void 0, target))
      target = {};
    if (source == null || !_chunk52BL3727cjs.isObject.call(void 0, source))
      continue;
    Object.keys(source).forEach((key) => {
      const targetValue = target[key];
      const sourceValue = source[key];
      if (Array.isArray(targetValue) && Array.isArray(sourceValue))
        target[key] = targetValue.concat(sourceValue);
      else if (_chunk52BL3727cjs.isObject.call(void 0, targetValue) && _chunk52BL3727cjs.isObject.call(void 0, sourceValue))
        target[key] = deepMerge(Object.assign({}, targetValue), sourceValue);
      else
        target[key] = sourceValue;
    });
  }
  return target;
}





exports.deepEqual = deepEqual; exports.deepStripUndefinedInPlace = deepStripUndefinedInPlace; exports.deepMerge = deepMerge;
//# sourceMappingURL=chunk-XVQVWCIE.cjs.map