"use strict";





var _chunkSF5226HTcjs = require('../../chunk-SF5226HT.cjs');
require('../../chunk-QP5Y3I6F.cjs');
require('../../chunk-TAKWLGAZ.cjs');
require('../../chunk-EBDUTZIB.cjs');

// src/common/data/convert.spec.ts
describe("convert", () => {
  it("should convert", () => {
    expect(_chunkSF5226HTcjs.valueToString.call(void 0, 123)).toBe("123");
    expect(_chunkSF5226HTcjs.valueToInteger.call(void 0, "123")).toBe(123);
    expect(_chunkSF5226HTcjs.valueToInteger.call(void 0, true)).toBe(1);
  });
  it("should print errors", () => {
    expect(_chunkSF5226HTcjs.renderMessages.call(void 0, ["Message", new Error("Hello")])).toContain(
      "Message Error: Hello"
    );
    expect(
      _chunkSF5226HTcjs.renderMessages.call(void 0, ["Message", new Error("Hello")], { trace: false })
    ).toBe("Message Error: Hello");
    expect(
      _chunkSF5226HTcjs.renderMessages.call(void 0, [
        "Message",
        { a: 1, b: null },
        null,
        void 0,
        Number.NaN,
        100,
        "string"
      ])
    ).toEqual(`Message {
  "a": 1,
  "b": null
} null undefined NaN 100 string`);
  });
  it("should have some bias", async () => {
    expect(_chunkSF5226HTcjs.valueToBoolean.call(void 0, "123")).toBe(false);
    expect(_chunkSF5226HTcjs.valueToBoolean.call(void 0, "1")).toBe(true);
    expect(_chunkSF5226HTcjs.valueToBoolean.call(void 0, "on")).toBe(true);
    expect(_chunkSF5226HTcjs.valueToBoolean.call(void 0, 1)).toBe(true);
    expect(_chunkSF5226HTcjs.valueToBoolean.call(void 0, 123)).toBe(true);
    expect(_chunkSF5226HTcjs.valueToBoolean.call(void 0, void 0)).toBe(false);
    expect(_chunkSF5226HTcjs.valueToBoolean.call(void 0, null)).toBe(false);
    expect(_chunkSF5226HTcjs.valueToBoolean.call(void 0, "")).toBe(false);
    expect(_chunkSF5226HTcjs.valueToBooleanNotFalse.call(void 0, "123")).toBe(true);
    expect(_chunkSF5226HTcjs.valueToBooleanNotFalse.call(void 0, "1")).toBe(true);
    expect(_chunkSF5226HTcjs.valueToBooleanNotFalse.call(void 0, "0")).toBe(false);
    expect(_chunkSF5226HTcjs.valueToBooleanNotFalse.call(void 0, "off")).toBe(false);
    expect(_chunkSF5226HTcjs.valueToBooleanNotFalse.call(void 0, 1)).toBe(true);
    expect(_chunkSF5226HTcjs.valueToBooleanNotFalse.call(void 0, 123)).toBe(true);
    expect(_chunkSF5226HTcjs.valueToBooleanNotFalse.call(void 0, void 0)).toBe(true);
    expect(_chunkSF5226HTcjs.valueToBooleanNotFalse.call(void 0, null)).toBe(true);
    expect(_chunkSF5226HTcjs.valueToBooleanNotFalse.call(void 0, "")).toBe(true);
  });
});
//# sourceMappingURL=convert.spec.cjs.map