import {
  renderMessages,
  valueToBoolean,
  valueToBooleanNotFalse,
  valueToInteger,
  valueToString
} from "../../chunk-OQSDTQAF.js";
import "../../chunk-WG6ZJDFQ.js";
import "../../chunk-VWBTJP5F.js";
import "../../chunk-LRAR7IPU.js";

// src/common/data/convert.spec.ts
describe("convert", () => {
  it("should convert", () => {
    expect(valueToString(123)).toBe("123");
    expect(valueToInteger("123")).toBe(123);
    expect(valueToInteger(true)).toBe(1);
  });
  it("should print errors", () => {
    expect(renderMessages(["Message", new Error("Hello")])).toContain(
      "Message Error: Hello"
    );
    expect(
      renderMessages(["Message", new Error("Hello")], { trace: false })
    ).toBe("Message Error: Hello");
    expect(
      renderMessages([
        "Message",
        { a: 1, b: null },
        null,
        void 0,
        Number.NaN,
        100,
        "string"
      ])
    ).toEqual(`Message {
  "a": 1,
  "b": null
} null undefined NaN 100 string`);
  });
  it("should have some bias", async () => {
    expect(valueToBoolean("123")).toBe(false);
    expect(valueToBoolean("1")).toBe(true);
    expect(valueToBoolean("on")).toBe(true);
    expect(valueToBoolean(1)).toBe(true);
    expect(valueToBoolean(123)).toBe(true);
    expect(valueToBoolean(void 0)).toBe(false);
    expect(valueToBoolean(null)).toBe(false);
    expect(valueToBoolean("")).toBe(false);
    expect(valueToBooleanNotFalse("123")).toBe(true);
    expect(valueToBooleanNotFalse("1")).toBe(true);
    expect(valueToBooleanNotFalse("0")).toBe(false);
    expect(valueToBooleanNotFalse("off")).toBe(false);
    expect(valueToBooleanNotFalse(1)).toBe(true);
    expect(valueToBooleanNotFalse(123)).toBe(true);
    expect(valueToBooleanNotFalse(void 0)).toBe(true);
    expect(valueToBooleanNotFalse(null)).toBe(true);
    expect(valueToBooleanNotFalse("")).toBe(true);
  });
});
//# sourceMappingURL=convert.spec.js.map