declare const DAY_MS = 86400000;
type DayValue = number;
type DayInput = DayValue | number | string | Date | [number, number?, number?];
declare function dayYear(day: DayValue): DayValue;
declare function dayMonth(day: DayValue): DayValue;
declare function dayDay(day: DayValue): DayValue;
declare function dayToParts(day: DayValue): [number, number, number];
declare function dayToDate(day: DayValue, utc?: boolean): Date;
declare function dayFromToday(): DayValue;
declare function dayFromAny(value: DayInput, utc?: boolean): DayValue | undefined;
declare function dayToDateUTC(day: DayValue): Date;
/** @deprecated use dayToDateUTC */
declare function dayToDateGMT(day: DayValue): Date;
declare function dayFromDate(date: Date, utc?: boolean): DayValue;
declare function dayFromDateUTC(date: Date): DayValue;
/** @deprecated use dayFromDateUTC */
declare function dayFromDateGMT(date: Date): DayValue;
declare function dayToTimestamp(day: DayValue, utc?: boolean): number;
declare function dayFromTimestamp(ms: number, utc?: boolean): DayValue;
declare function dayToString(day: DayValue, sep?: string): string;
declare function dayFromParts(year: number, month?: number, day?: number): DayValue | undefined;
declare function dayFromString(value: string): DayValue | undefined;
declare function dayMonthStart(day: DayValue, offset?: number): DayValue;
declare function dayYearStart(day: DayValue, offset?: number): DayValue;
declare function dayOffset(day: DayValue, offset: number): DayValue;
declare function dayDiff(left: DayValue, right: DayValue): number;
/** List of dates for loops */
declare function dayRange(left: DayValue, right?: DayValue): number[];
/** Iterator, see dayRange */
declare function dayIterator(left: DayValue, right?: DayValue): Generator<number, number[], unknown>;

export { DAY_MS, type DayInput, type DayValue, dayDay, dayDiff, dayFromAny, dayFromDate, dayFromDateGMT, dayFromDateUTC, dayFromParts, dayFromString, dayFromTimestamp, dayFromToday, dayIterator, dayMonth, dayMonthStart, dayOffset, dayRange, dayToDate, dayToDateGMT, dayToDateUTC, dayToParts, dayToString, dayToTimestamp, dayYear, dayYearStart };
