"use strict";



var _chunkTAKWLGAZcjs = require('../../chunk-TAKWLGAZ.cjs');
require('../../chunk-EBDUTZIB.cjs');

// src/common/data/json.spec.ts
describe("convert", () => {
  it("should jsonStringify", () => {
    const circularObj = {};
    circularObj.circularRef = circularObj;
    circularObj.list = [circularObj, circularObj];
    expect(_chunkTAKWLGAZcjs.jsonStringifySafe.call(void 0, circularObj)).toBe(
      '{"circularRef":"[Circular ~]","list":["[Circular ~]","[Circular ~]"]}'
    );
  });
  it("should jsonStringify class", () => {
    class TestBase {
    }
    class Test extends TestBase {
      constructor(databaseID) {
        super();
        this.id = databaseID;
      }
    }
    const t = new Test(new Uint8Array([1, 2, 3]));
    expect(_chunkTAKWLGAZcjs.jsonStringifySafe.call(void 0, t)).toMatchInlineSnapshot(`"{"id":{"0":1,"1":2,"2":3}}"`);
  });
  it("should jsonParse", () => {
    const input = '{ "user": { "__proto__": { "isAdmin": true } } }';
    expect(_chunkTAKWLGAZcjs.jsonParse.call(void 0, input)).toEqual({ user: {} });
  });
  it("should sort", () => {
    const a = _chunkTAKWLGAZcjs.jsonStringifySorted.call(void 0, { a: 1, b: 2 });
    const b = _chunkTAKWLGAZcjs.jsonStringifySorted.call(void 0, { b: 2, a: 1 });
    expect(a).toEqual(b);
  });
  it("should sort and safe", () => {
    const a = _chunkTAKWLGAZcjs.jsonStringifySafe.call(void 0, { a: 1, b: 2 });
    const b = JSON.stringify({ a: 1, b: 2 });
    expect(a).toEqual(b);
  });
});
//# sourceMappingURL=json.spec.cjs.map