"use strict";





var _chunkPJXRDQ2Acjs = require('../../chunk-PJXRDQ2A.cjs');
require('../../chunk-EBDUTZIB.cjs');

// src/common/data/math.spec.ts
describe("math", () => {
  it("should not have collisions", () => {
    const list = Array.apply(null, Array(1e3)).map(
      () => _chunkPJXRDQ2Acjs.getSecureRandom.call(void 0, )
    );
    let id;
    while (id = list.pop()) {
      expect(id >= 0).toBe(true);
      expect(id < 1).toBe(true);
      expect(list).not.toContain(id);
    }
  });
  it("should bias", () => {
    let sum = 0;
    for (let i = 0; i < 1e3; i++)
      sum += _chunkPJXRDQ2Acjs.randomBoolean.call(void 0, 0.1) ? 1 : 0;
    expect(sum / 1e3).toBeLessThan(0.2);
  });
  it("should recog primes rx", () => {
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 1)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 2)).toBe(true);
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 3)).toBe(true);
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 4)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 5)).toBe(true);
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 6)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 7)).toBe(true);
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 8)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 9)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 10)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrimeRX.call(void 0, 11)).toBe(true);
  });
  it("should recog primes", () => {
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 1)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 2)).toBe(true);
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 3)).toBe(true);
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 4)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 5)).toBe(true);
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 6)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 7)).toBe(true);
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 8)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 9)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 10)).toBe(false);
    expect(_chunkPJXRDQ2Acjs.isPrime.call(void 0, 11)).toBe(true);
  });
  it("should not be random", () => {
    expect([
      _chunkPJXRDQ2Acjs.seededRandom.call(void 0, ),
      _chunkPJXRDQ2Acjs.seededRandom.call(void 0, ),
      _chunkPJXRDQ2Acjs.seededRandom.call(void 0, ),
      _chunkPJXRDQ2Acjs.seededRandom.call(void 0, ),
      _chunkPJXRDQ2Acjs.seededRandom.call(void 0, ),
      _chunkPJXRDQ2Acjs.seededRandom.call(void 0, ),
      _chunkPJXRDQ2Acjs.seededRandom.call(void 0, )
    ]).toMatchInlineSnapshot(`
      Array [
        0.5494555898491084,
        0.2751200274348422,
        0.6800540123456791,
        0.9710476680384088,
        0.5030392661179699,
        0.5568930041152264,
        0.4505101165980796,
      ]
    `);
  });
});
//# sourceMappingURL=math.spec.cjs.map