import {
  toValidFilename
} from "../../chunk-TYWNSO7K.js";
import "../../chunk-ZMFW3O35.js";
import "../../chunk-LRAR7IPU.js";

// src/common/data/path.spec.ts
describe("path.spec", () => {
  it("should fix filenames", async () => {
    const samples = [
      "prn",
      "a/b/c/d.txt",
      "a\\b\\c\\d.txt",
      "trailing...",
      "...leading",
      'illegal start \\/:*?"<>| end',
      "crazy 	 white \n space \0 nil",
      "fancy \u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466} family \u21D2 \u2205 \u274C \u{1F602}.txt"
    ];
    expect(samples.map((s) => toValidFilename(s, " "))).toMatchInlineSnapshot(`
      Array [
        "prn ",
        "a b c d.txt",
        "a b c d.txt",
        "trailing",
        "leading",
        "illegal start end",
        "crazy white space nil",
        "fancy \u{1F468}\u200D\u{1F469}\u200D\u{1F467}\u200D\u{1F466} family \u21D2 \u2205 \u274C \u{1F602}.txt",
      ]
    `);
  });
});
//# sourceMappingURL=path.spec.js.map