import {
  useSignal
} from "../../chunk-3SMFSMCY.js";
import "../../chunk-DUON5DN5.js";
import "../../chunk-GY34N3KU.js";
import "../../chunk-IZT6OHMS.js";
import "../../chunk-LRAR7IPU.js";

// src/common/data/signal.spec.ts
describe("signal", () => {
  it("should signal", async () => {
    let copy;
    let count = 1;
    const [flag, setFlag] = useSignal(true, (v) => copy = v);
    const name = useSignal("Henry");
    const object = useSignal({
      a: 1,
      b: 2
    });
    const off = name.on((v) => ++count);
    expect(flag()).toEqual(true);
    expect(name.get()).toEqual("Henry");
    expect(copy).toEqual(void 0);
    expect(object.get()).toEqual({
      a: 1,
      b: 2
    });
    setFlag(false);
    name.set("Anna");
    object.set({
      a: 11,
      b: 22
    });
    expect(flag()).toEqual(false);
    expect(name.get()).toEqual("Anna");
    expect(copy).toEqual(false);
    expect(object.get()).toEqual({
      a: 11,
      b: 22
    });
    expect(count).toBe(2);
    name.set("Anna");
    expect(count).toBe(2);
    name.set("Cloe");
    expect(count).toBe(3);
    off();
    name.set("Diego");
    expect(count).toBe(3);
  });
});
//# sourceMappingURL=signal.spec.js.map