"use strict";



var _chunkWJLGDUG7cjs = require('../chunk-WJLGDUG7.cjs');
require('../chunk-S6C2I4HY.cjs');
require('../chunk-TVG2N27I.cjs');
require('../chunk-2K7CMJLH.cjs');
require('../chunk-ZO3HNLXY.cjs');
require('../chunk-TSD5DD6R.cjs');
require('../chunk-IXCEHUIO.cjs');
require('../chunk-XVSXTYYC.cjs');
require('../chunk-LARONVYA.cjs');
require('../chunk-MGRD2O72.cjs');
require('../chunk-F2L2RVEN.cjs');
require('../chunk-ZOA7N26R.cjs');
require('../chunk-BNY33VPP.cjs');


var _chunkVLHGYWYEcjs = require('../chunk-VLHGYWYE.cjs');
require('../chunk-4B2XCWGL.cjs');
require('../chunk-5CIFX7O6.cjs');
require('../chunk-ZFHTACEU.cjs');
require('../chunk-XYGMYIEV.cjs');
require('../chunk-H7G364FQ.cjs');
require('../chunk-GHLV6X4H.cjs');
require('../chunk-U7QCFBCQ.cjs');
require('../chunk-UKD65B23.cjs');
require('../chunk-WMBXBB3K.cjs');
require('../chunk-J42M6DF3.cjs');
require('../chunk-N46W55MH.cjs');
require('../chunk-L646RZQB.cjs');
require('../chunk-ZYPCVNSG.cjs');
require('../chunk-VFIICDKU.cjs');
require('../chunk-A4VFMLAN.cjs');
require('../chunk-RZKLDILW.cjs');
require('../chunk-DRTH56G4.cjs');
require('../chunk-XWE2OTGL.cjs');
require('../chunk-KTC5RW57.cjs');
require('../chunk-XR7AMYN7.cjs');
require('../chunk-B4JXPT6I.cjs');
require('../chunk-ZTXHUURC.cjs');
require('../chunk-NEUX2E3A.cjs');
require('../chunk-RKOTNV3K.cjs');
require('../chunk-6BXZXESY.cjs');
require('../chunk-7ZVZ6CJO.cjs');
require('../chunk-ZGKV237Z.cjs');
require('../chunk-FEYF6QXS.cjs');
require('../chunk-CRY7SVRY.cjs');
require('../chunk-N7OUNPMM.cjs');
require('../chunk-MPD2DJAD.cjs');
require('../chunk-FFTVVGZI.cjs');
require('../chunk-N5KTMDVO.cjs');
require('../chunk-5KIDARFB.cjs');
require('../chunk-YELWQAMG.cjs');
require('../chunk-XVQVWCIE.cjs');
require('../chunk-52BL3727.cjs');
require('../chunk-SF5226HT.cjs');
require('../chunk-L5SJIWCK.cjs');
require('../chunk-DRQTDJSC.cjs');
require('../chunk-6T6PI6XG.cjs');
require('../chunk-PJXRDQ2A.cjs');
require('../chunk-5K46PLWP.cjs');
require('../chunk-FYLSPYV2.cjs');
require('../chunk-YKRFYR2Q.cjs');
require('../chunk-7FO3T7KH.cjs');
require('../chunk-BMRI2X66.cjs');
require('../chunk-QP5Y3I6F.cjs');
require('../chunk-TAKWLGAZ.cjs');



var _chunkEBDUTZIBcjs = require('../chunk-EBDUTZIB.cjs');

// src/common/dispose-utils.spec.ts
var _vitest = require('vitest');
describe("useTimeout", () => {
  it("should call the provided function after the specified timeout", () => {
    _vitest.vi.useFakeTimers();
    const mockFn = _vitest.vi.fn();
    const timeout = 1e3;
    _chunkWJLGDUG7cjs.useTimeout.call(void 0, mockFn, timeout);
    expect(mockFn).not.toBeCalled();
    _vitest.vi.advanceTimersByTime(timeout);
    expect(mockFn).toBeCalled();
  });
  it("should cancel the timeout when the disposer function is called", () => {
    _vitest.vi.useFakeTimers();
    const mockFn = _vitest.vi.fn();
    const timeout = 1e3;
    const disposer = _chunkWJLGDUG7cjs.useTimeout.call(void 0, mockFn, timeout);
    expect(mockFn).not.toBeCalled();
    disposer();
    _vitest.vi.advanceTimersByTime(timeout);
    expect(mockFn).not.toBeCalled();
  });
  it('should add event listener using "on" method if available', () => {
    const emitter = {
      on: _vitest.vi.fn(),
      off: _vitest.vi.fn()
    };
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const disposer = _chunkWJLGDUG7cjs.useEventListener.call(void 0, emitter, eventName, fn, ...args);
    expect(emitter.on).toBeCalledWith(eventName, fn, ...args);
    expect(emitter.off).not.toBeCalled();
    disposer();
    expect(emitter.off).toBeCalledWith(eventName, fn, ...args);
  });
  it('should add event listener using "on" method if available using using', () => {
    const emitter = {
      on: _vitest.vi.fn(),
      off: _vitest.vi.fn()
    };
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    _chunkVLHGYWYEcjs.polyfillUsing.call(void 0, );
    function helper() {
      var _stack = [];
      try {
        const _ = _chunkEBDUTZIBcjs.__using.call(void 0, _stack, _chunkWJLGDUG7cjs.useEventListener.call(void 0, emitter, eventName, fn, ...args));
        expect(emitter.on).toBeCalledWith(eventName, fn, ...args);
        expect(emitter.off).not.toBeCalled();
      } catch (_2) {
        var _error = _2, _hasError = true;
      } finally {
        _chunkEBDUTZIBcjs.__callDispose.call(void 0, _stack, _error, _hasError);
      }
    }
    helper();
    expect(emitter.off).toBeCalledWith(eventName, fn, ...args);
  });
  it('should add event listener using "addEventListener" method if "on" method is not available', () => {
    const emitter = {
      addEventListener: _vitest.vi.fn(),
      removeEventListener: _vitest.vi.fn()
    };
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const disposer = _chunkWJLGDUG7cjs.useEventListener.call(void 0, emitter, eventName, fn, ...args);
    expect(emitter.addEventListener).toBeCalledWith(eventName, fn, ...args);
    expect(emitter.removeEventListener).not.toBeCalled();
    disposer();
    expect(emitter.removeEventListener).toBeCalledWith(eventName, fn, ...args);
  });
  it("should return an empty disposer function if emitter is null", () => {
    const emitter = null;
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const disposer = _chunkWJLGDUG7cjs.useEventListener.call(void 0, emitter, eventName, fn, ...args);
    expect(disposer).toEqual(expect.any(Function));
    disposer();
  });
  it("should add timeout disposer to the dispose object", () => {
    _vitest.vi.useFakeTimers();
    const mockFn = _vitest.vi.fn();
    const timeout = 1e3;
    const dispose = _chunkWJLGDUG7cjs.useDisposeWithUtils.call(void 0, );
    dispose.timeout(mockFn, timeout);
    expect(mockFn).not.toBeCalled();
    _vitest.vi.advanceTimersByTime(timeout);
    expect(mockFn).toBeCalled();
  });
  it("should add interval disposer to the dispose object", () => {
    _vitest.vi.useFakeTimers();
    const mockFn = _vitest.vi.fn();
    const interval = 1e3;
    const dispose = _chunkWJLGDUG7cjs.useDisposeWithUtils.call(void 0, );
    dispose.interval(mockFn, interval);
    expect(mockFn).not.toBeCalled();
    _vitest.vi.advanceTimersByTime(interval);
    expect(mockFn).toBeCalled();
  });
  it('should add event listener disposer to the dispose object using "on" method', async () => {
    const emitter = {
      on: _vitest.vi.fn(),
      off: _vitest.vi.fn()
    };
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const dispose = _chunkWJLGDUG7cjs.useDisposeWithUtils.call(void 0, );
    dispose.on(emitter, eventName, fn, ...args);
    expect(emitter.on).toBeCalledWith(eventName, fn, ...args);
    expect(emitter.off).not.toBeCalled();
    await dispose.dispose();
    expect(emitter.off).toBeCalledWith(eventName, fn, ...args);
  });
  it('should add event listener disposer to the dispose object using "addEventListener" method', async () => {
    const emitter = {
      addEventListener: _vitest.vi.fn(),
      removeEventListener: _vitest.vi.fn()
    };
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const dispose = _chunkWJLGDUG7cjs.useDisposeWithUtils.call(void 0, );
    dispose.on(emitter, eventName, fn, ...args);
    expect(emitter.addEventListener).toBeCalledWith(eventName, fn, ...args);
    expect(emitter.removeEventListener).not.toBeCalled();
    await dispose.dispose();
    expect(emitter.removeEventListener).toBeCalledWith(eventName, fn, ...args);
  });
  it("should return an empty disposer function if emitter is null 2", () => {
    const emitter = null;
    const eventName = "click";
    const fn = _vitest.vi.fn();
    const args = [1, 2, 3];
    const dispose = _chunkWJLGDUG7cjs.useDisposeWithUtils.call(void 0, );
    const disposer = dispose.on(emitter, eventName, fn, ...args);
    expect(disposer).toEqual(expect.any(Function));
    disposer();
  });
});
//# sourceMappingURL=dispose-utils.spec.cjs.map