"use strict";

var _chunkWJLGDUG7cjs = require('../../chunk-WJLGDUG7.cjs');
require('../../chunk-S6C2I4HY.cjs');
require('../../chunk-TVG2N27I.cjs');
require('../../chunk-2K7CMJLH.cjs');
require('../../chunk-ZO3HNLXY.cjs');
require('../../chunk-TSD5DD6R.cjs');
require('../../chunk-IXCEHUIO.cjs');
require('../../chunk-XVSXTYYC.cjs');
require('../../chunk-LARONVYA.cjs');
require('../../chunk-MGRD2O72.cjs');
require('../../chunk-F2L2RVEN.cjs');
require('../../chunk-ZOA7N26R.cjs');
require('../../chunk-BNY33VPP.cjs');
require('../../chunk-VLHGYWYE.cjs');
require('../../chunk-4B2XCWGL.cjs');
require('../../chunk-5CIFX7O6.cjs');
require('../../chunk-ZFHTACEU.cjs');
require('../../chunk-XYGMYIEV.cjs');
require('../../chunk-H7G364FQ.cjs');
require('../../chunk-GHLV6X4H.cjs');
require('../../chunk-U7QCFBCQ.cjs');
require('../../chunk-UKD65B23.cjs');
require('../../chunk-WMBXBB3K.cjs');
require('../../chunk-J42M6DF3.cjs');
require('../../chunk-N46W55MH.cjs');
require('../../chunk-L646RZQB.cjs');
require('../../chunk-ZYPCVNSG.cjs');
require('../../chunk-VFIICDKU.cjs');
require('../../chunk-A4VFMLAN.cjs');
require('../../chunk-RZKLDILW.cjs');
require('../../chunk-DRTH56G4.cjs');
require('../../chunk-XWE2OTGL.cjs');
require('../../chunk-KTC5RW57.cjs');
require('../../chunk-XR7AMYN7.cjs');
require('../../chunk-B4JXPT6I.cjs');
require('../../chunk-ZTXHUURC.cjs');
require('../../chunk-NEUX2E3A.cjs');
require('../../chunk-RKOTNV3K.cjs');
require('../../chunk-6BXZXESY.cjs');
require('../../chunk-7ZVZ6CJO.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-CRY7SVRY.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-FFTVVGZI.cjs');
require('../../chunk-N5KTMDVO.cjs');
require('../../chunk-5KIDARFB.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-XVQVWCIE.cjs');
require('../../chunk-52BL3727.cjs');
require('../../chunk-SF5226HT.cjs');
require('../../chunk-L5SJIWCK.cjs');
require('../../chunk-DRQTDJSC.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-PJXRDQ2A.cjs');
require('../../chunk-5K46PLWP.cjs');
require('../../chunk-FYLSPYV2.cjs');
require('../../chunk-YKRFYR2Q.cjs');
require('../../chunk-7FO3T7KH.cjs');
require('../../chunk-BMRI2X66.cjs');
require('../../chunk-QP5Y3I6F.cjs');
require('../../chunk-TAKWLGAZ.cjs');
require('../../chunk-EBDUTZIB.cjs');

// src/common/exec/progress.spec.ts
describe("progress.spec", () => {
  it("should track progress", async () => {
    const p = new (0, _chunkWJLGDUG7cjs.Progress)({
      name: "root",
      totalUnits: 10
    });
    expect(p.getFraction()).toBe(0);
    p.incCompletedUnits();
    expect(p.getTotalUnits()).toBe(10);
    expect(p.getCompletedUnits()).toBe(1);
    expect(p.getFraction()).toBe(0.1);
    const pp = new (0, _chunkWJLGDUG7cjs.Progress)();
    p.addChild(pp);
    expect(p.getChildrenCount()).toBe(1);
    expect(p.getFraction()).toBe(0.1);
    pp.setTotalUnits(10);
    expect(p.getFraction()).toBe(0.05);
    pp.incCompletedUnits(5);
    expect(p.getTotalUnits()).toBe(20);
    expect(p.getCompletedUnits()).toBe(6);
    expect(p.getFraction()).toBe(0.3);
    expect(p.toString()).toMatchInlineSnapshot(`
      "root: 1 of 10 units, 30 %, cancel=false
        progress-0: 5 of 10 units, 50 %, cancel=false"
    `);
    expect(pp.isFinished()).toBe(false);
    expect(p.getChildrenCount()).toBe(1);
    await pp.dispose();
    expect(p.getChildrenCount()).toBe(0);
    expect(pp.isFinished()).toBe(true);
    expect(p.getTotalUnits()).toBe(10);
    expect(p.getCompletedUnits()).toBe(1);
    expect(p.getFraction()).toBe(0.1);
    expect(p.isFinished()).toBe(false);
    p.setCompletetedUnits(10);
    expect(p.getFraction()).toBe(1);
    expect(p.isFinished()).toBe(true);
  });
  it("should cancel and auto reset", async () => {
    const p = new (0, _chunkWJLGDUG7cjs.Progress)({
      totalUnits: 10
    });
    expect(p.isCancelled()).toBe(false);
    await p.cancel();
    expect(p.isCancelled()).toBe(true);
    p.incCompletedUnits(10);
    expect(p.isFinished()).toBe(true);
    expect(p.isCancelled()).toBe(false);
  });
});
//# sourceMappingURL=progress.spec.cjs.map