type OriginalConsole = Pick<Console, 'log' | 'info' | 'warn' | 'error' | 'debug'> & {
    console: Console;
};
declare global {
    interface ZeedGlobalContext {
        originalConsole?: OriginalConsole;
    }
}
/**
 * Retrieves the global console object, ensuring that it is stored in the global context.
 * If the global context does not have a reference to the original console object, it creates one.
 * The original console object is then bound to the global context, allowing access to its methods.
 */
declare function getGlobalConsole(): OriginalConsole;

export { type OriginalConsole, getGlobalConsole };
