"use strict";


var _chunk6MBQJIO3cjs = require('../../chunk-6MBQJIO3.cjs');
require('../../chunk-JCNZZG5S.cjs');
require('../../chunk-MISU7G26.cjs');
require('../../chunk-SFUIGVPA.cjs');
require('../../chunk-X23ZSPZC.cjs');
require('../../chunk-2UTQQDPY.cjs');
require('../../chunk-5KZAXCCX.cjs');



var _chunkTVG2N27Icjs = require('../../chunk-TVG2N27I.cjs');


var _chunkIXCEHUIOcjs = require('../../chunk-IXCEHUIO.cjs');
require('../../chunk-XVSXTYYC.cjs');
require('../../chunk-ZOA7N26R.cjs');
require('../../chunk-BNY33VPP.cjs');
require('../../chunk-VLHGYWYE.cjs');
require('../../chunk-4B2XCWGL.cjs');
require('../../chunk-5CIFX7O6.cjs');
require('../../chunk-ZFHTACEU.cjs');
require('../../chunk-XYGMYIEV.cjs');
require('../../chunk-H7G364FQ.cjs');
require('../../chunk-GHLV6X4H.cjs');
require('../../chunk-U7QCFBCQ.cjs');
require('../../chunk-UKD65B23.cjs');
require('../../chunk-WMBXBB3K.cjs');
require('../../chunk-J42M6DF3.cjs');
require('../../chunk-N46W55MH.cjs');
require('../../chunk-L646RZQB.cjs');
require('../../chunk-ZYPCVNSG.cjs');
require('../../chunk-VFIICDKU.cjs');
require('../../chunk-A4VFMLAN.cjs');
require('../../chunk-RZKLDILW.cjs');
require('../../chunk-DRTH56G4.cjs');
require('../../chunk-XWE2OTGL.cjs');
require('../../chunk-KTC5RW57.cjs');


var _chunkXR7AMYN7cjs = require('../../chunk-XR7AMYN7.cjs');
require('../../chunk-B4JXPT6I.cjs');
require('../../chunk-ZTXHUURC.cjs');
require('../../chunk-NEUX2E3A.cjs');
require('../../chunk-RKOTNV3K.cjs');
require('../../chunk-6BXZXESY.cjs');
require('../../chunk-7ZVZ6CJO.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-CRY7SVRY.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-FFTVVGZI.cjs');


var _chunkN5KTMDVOcjs = require('../../chunk-N5KTMDVO.cjs');
require('../../chunk-5KIDARFB.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-XVQVWCIE.cjs');
require('../../chunk-52BL3727.cjs');
require('../../chunk-SF5226HT.cjs');
require('../../chunk-L5SJIWCK.cjs');
require('../../chunk-DRQTDJSC.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-PJXRDQ2A.cjs');
require('../../chunk-5K46PLWP.cjs');
require('../../chunk-FYLSPYV2.cjs');
require('../../chunk-YKRFYR2Q.cjs');


var _chunk7FO3T7KHcjs = require('../../chunk-7FO3T7KH.cjs');
require('../../chunk-BMRI2X66.cjs');
require('../../chunk-QP5Y3I6F.cjs');
require('../../chunk-TAKWLGAZ.cjs');
require('../../chunk-EBDUTZIB.cjs');

// src/common/msg/rpc.spec.ts
var bobCount = 0;
var Bob = {
  hi(name) {
    return `Hi ${name}, I am Bob`;
  },
  bump() {
    bobCount += 1;
  },
  getCount() {
    return bobCount;
  }
};
var Alice = {
  hello(name) {
    return `Hello ${name}, my name is Alice`;
  }
};
describe("rpc async", () => {
  beforeEach(() => {
    bobCount = 0;
  });
  it("basic", async () => {
    const log = [];
    const [c1, c2] = _chunkIXCEHUIOcjs.createLocalChannelPair.call(void 0, );
    const serialize = (data) => {
      log.push(_chunk7FO3T7KHcjs.cloneObject.call(void 0, data));
      return _chunk6MBQJIO3cjs.encodeJson.call(void 0, data);
    };
    const deserialize = (data) => _chunk6MBQJIO3cjs.decodeJson.call(void 0, data);
    const bob = _chunkTVG2N27Icjs.useRPC.call(void 0, Bob, {
      post: (data) => c1.postMessage(data),
      on: (data) => c1.on("message", (e) => data(e.data)),
      serialize,
      deserialize,
      stringHashPool: _chunkXR7AMYN7cjs.useStringHashPool.call(void 0, )
    });
    const alice = _chunkTVG2N27Icjs.useRPC.call(void 0, Alice, {
      // mark bob's `bump` as an event without response
      eventNames: ["bump"],
      post: (data) => c2.postMessage(data),
      on: (data) => c2.on("message", (e) => data(e.data)),
      serialize,
      deserialize,
      stringHashPool: _chunkXR7AMYN7cjs.useStringHashPool.call(void 0, )
    });
    expect(await bob.hello("Bob")).toEqual("Hello Bob, my name is Alice");
    expect(await alice.hi("Alice")).toEqual("Hi Alice, I am Bob");
    expect(void alice.bump()).toBeUndefined();
    expect(Bob.getCount()).toBe(0);
    await new Promise((resolve) => setTimeout(resolve, 100));
    expect(Bob.getCount()).toBe(1);
    c1.close();
    c2.close();
    expect(log).toMatchInlineSnapshot(`
      Array [
        Array [
          1,
          1,
          1335831723,
          "Bob",
        ],
        Array [
          3,
          1,
          "Hello Bob, my name is Alice",
        ],
        Array [
          1,
          2,
          1748694682,
          "Alice",
        ],
        Array [
          3,
          2,
          "Hi Alice, I am Bob",
        ],
        Array [
          2,
          1648103349,
        ],
      ]
    `);
  });
  it("hub", async () => {
    const [c1, c2] = _chunkIXCEHUIOcjs.createLocalChannelPair.call(void 0, );
    const serialize = (data) => _chunk6MBQJIO3cjs.encodeJson.call(void 0, data);
    const deserialize = (data) => _chunk6MBQJIO3cjs.decodeJson.call(void 0, data);
    const bobHub = _chunkTVG2N27Icjs.useRPCHub.call(void 0, {
      post: (data) => c1.postMessage(data),
      on: (data) => c1.on("message", (e) => data(e.data)),
      serialize,
      deserialize,
      stringHashPool: _chunkXR7AMYN7cjs.useStringHashPool.call(void 0, )
    });
    const bob = bobHub(Bob);
    const alice = _chunkTVG2N27Icjs.useRPC.call(void 0, Alice, {
      // mark bob's `bump` as an event without response
      eventNames: ["bump"],
      post: (data) => c2.postMessage(data),
      on: (data) => c2.on("message", (e) => data(e.data)),
      serialize,
      deserialize,
      stringHashPool: _chunkXR7AMYN7cjs.useStringHashPool.call(void 0, )
    });
    expect(await bob.hello("Bob")).toEqual("Hello Bob, my name is Alice");
    expect(await alice.hi("Alice")).toEqual("Hi Alice, I am Bob");
    expect(void alice.bump()).toBeUndefined();
    expect(Bob.getCount()).toBe(0);
    await new Promise((resolve) => setTimeout(resolve, 100));
    expect(Bob.getCount()).toBe(1);
    c1.close();
    c2.close();
  });
  it("timeout async", async (done) => {
    const [f1, f2] = _chunkIXCEHUIOcjs.createLocalChannelPair.call(void 0, );
    const rpc1 = _chunkTVG2N27Icjs.useRPC.call(void 0, {
      async echo(v, s = 5) {
        await _chunkN5KTMDVOcjs.sleep.call(void 0, s);
        return `${v}_1`;
      }
    }, {
      post: (data) => {
        f1.postMessage(data);
      },
      on: (data) => f1.on("message", (msg) => {
        void data(msg.data);
      }),
      timeout: 10
    });
    const rpc2 = _chunkTVG2N27Icjs.useRPC.call(void 0, {
      async echo(v, s = 5) {
        await _chunkN5KTMDVOcjs.sleep.call(void 0, s);
        return `${v}_2`;
      }
    }, {
      post: (data) => {
        f2.postMessage(data);
      },
      on: (data) => f2.on("message", (msg) => {
        void data(msg.data);
      }),
      timeout: 10
    });
    const r = await rpc1.echo("abc");
    expect(r).toMatchInlineSnapshot(`"abc_2"`);
    try {
      const r2 = await rpc1.echo("abc", 50);
      expect(false).toBe(true);
    } catch (err) {
      expect(err).toMatchInlineSnapshot(`[Error: rpc timeout on calling "echo"]`);
    }
  });
  it("async", async (done) => {
    function echo(n) {
      return n;
    }
    async function echoAsync(n) {
      return n;
    }
    expect(await echo(1)).toBe(1);
    expect(await echoAsync(2)).toBe(2);
  });
});
//# sourceMappingURL=rpc.spec.cjs.map