"use strict";



var _chunkTPUVIKMVcjs = require('../chunk-TPUVIKMV.cjs');
require('../chunk-TZOPYZVR.cjs');
require('../chunk-TBWBBQXT.cjs');
require('../chunk-IB5IYYW3.cjs');
require('../chunk-Q2SNIYQS.cjs');
require('../chunk-MBFXWDW2.cjs');
require('../chunk-6MBQJIO3.cjs');
require('../chunk-JCNZZG5S.cjs');
require('../chunk-MISU7G26.cjs');
require('../chunk-SFUIGVPA.cjs');
require('../chunk-X23ZSPZC.cjs');
require('../chunk-2UTQQDPY.cjs');
require('../chunk-MJ7L4G3V.cjs');
require('../chunk-CSTIENVQ.cjs');
require('../chunk-EZIDDVJG.cjs');
require('../chunk-3TNVJY4F.cjs');
require('../chunk-WPWV7ZEM.cjs');
require('../chunk-H6AB4FMJ.cjs');
require('../chunk-5KZAXCCX.cjs');
require('../chunk-4HLDMY5U.cjs');
require('../chunk-WJLGDUG7.cjs');
require('../chunk-S6C2I4HY.cjs');
require('../chunk-TVG2N27I.cjs');
require('../chunk-2K7CMJLH.cjs');
require('../chunk-ZO3HNLXY.cjs');
require('../chunk-TSD5DD6R.cjs');
require('../chunk-IXCEHUIO.cjs');
require('../chunk-XVSXTYYC.cjs');
require('../chunk-LARONVYA.cjs');
require('../chunk-MGRD2O72.cjs');
require('../chunk-F2L2RVEN.cjs');
require('../chunk-ZOA7N26R.cjs');
require('../chunk-BNY33VPP.cjs');
require('../chunk-VLHGYWYE.cjs');
require('../chunk-4B2XCWGL.cjs');
require('../chunk-5CIFX7O6.cjs');
require('../chunk-ZFHTACEU.cjs');
require('../chunk-XYGMYIEV.cjs');
require('../chunk-H7G364FQ.cjs');
require('../chunk-GHLV6X4H.cjs');
require('../chunk-U7QCFBCQ.cjs');
require('../chunk-UKD65B23.cjs');
require('../chunk-WMBXBB3K.cjs');
require('../chunk-J42M6DF3.cjs');
require('../chunk-N46W55MH.cjs');
require('../chunk-L646RZQB.cjs');
require('../chunk-ZYPCVNSG.cjs');
require('../chunk-VFIICDKU.cjs');
require('../chunk-A4VFMLAN.cjs');
require('../chunk-RZKLDILW.cjs');
require('../chunk-DRTH56G4.cjs');
require('../chunk-XWE2OTGL.cjs');
require('../chunk-KTC5RW57.cjs');
require('../chunk-XR7AMYN7.cjs');
require('../chunk-B4JXPT6I.cjs');
require('../chunk-ZTXHUURC.cjs');
require('../chunk-NEUX2E3A.cjs');
require('../chunk-RKOTNV3K.cjs');
require('../chunk-6BXZXESY.cjs');
require('../chunk-7ZVZ6CJO.cjs');
require('../chunk-ZGKV237Z.cjs');
require('../chunk-FEYF6QXS.cjs');
require('../chunk-CRY7SVRY.cjs');
require('../chunk-N7OUNPMM.cjs');
require('../chunk-MPD2DJAD.cjs');
require('../chunk-FFTVVGZI.cjs');
require('../chunk-N5KTMDVO.cjs');
require('../chunk-5KIDARFB.cjs');
require('../chunk-YELWQAMG.cjs');
require('../chunk-XVQVWCIE.cjs');
require('../chunk-52BL3727.cjs');
require('../chunk-SF5226HT.cjs');
require('../chunk-L5SJIWCK.cjs');
require('../chunk-DRQTDJSC.cjs');
require('../chunk-6T6PI6XG.cjs');
require('../chunk-PJXRDQ2A.cjs');
require('../chunk-5K46PLWP.cjs');
require('../chunk-FYLSPYV2.cjs');
require('../chunk-YKRFYR2Q.cjs');
require('../chunk-7FO3T7KH.cjs');
require('../chunk-BMRI2X66.cjs');
require('../chunk-QP5Y3I6F.cjs');
require('../chunk-TAKWLGAZ.cjs');
require('../chunk-EBDUTZIB.cjs');

// src/node/files-async.spec.ts
describe("getStatAsync", () => {
  it("should return the stat object for a valid path", async () => {
    const path = __filename;
    const statObject = await _chunkTPUVIKMVcjs.getStatAsync.call(void 0, path);
    expect(statObject).toBeDefined();
    expect(statObject.isFile()).toBe(true);
  });
  it("should return undefined for an invalid path", async () => {
    const path = "/invalid/path";
    const statObject = await _chunkTPUVIKMVcjs.getStatAsync.call(void 0, path);
    expect(statObject).toBeUndefined();
  });
  it("should return the fingerprint for a valid path", async () => {
    const path = __filename;
    const fingerprint = await _chunkTPUVIKMVcjs.getFingerprintAsync.call(void 0, path);
    expect(fingerprint).toBeDefined();
    expect(typeof fingerprint).toBe("string");
  });
  it("should return undefined for an invalid path 2", async () => {
    const path = "/invalid/path";
    const fingerprint = await _chunkTPUVIKMVcjs.getFingerprintAsync.call(void 0, path);
    expect(fingerprint).toBeUndefined();
  });
  it("should return an array of file paths", async () => {
    const paths = await _chunkTPUVIKMVcjs.filesAsync.call(void 0, { basePath: __dirname });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.length).toBeGreaterThan(0);
    expect(typeof paths[0]).toBe("string");
  });
  it("should return an array of file paths matching the pattern", async () => {
    const pattern = "*.ts";
    const paths = await _chunkTPUVIKMVcjs.filesAsync.call(void 0, { basePath: __dirname, pattern });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.length).toBeGreaterThan(0);
    expect(typeof paths[0]).toBe("string");
    expect(paths.every((path) => path.endsWith(".ts"))).toBe(true);
  });
  it("should return an empty array if no files match the pattern", async () => {
    const pattern = "*.docx";
    const paths = await _chunkTPUVIKMVcjs.filesAsync.call(void 0, { basePath: __dirname, pattern });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.length).toBe(0);
  });
  it("should return an array of file paths filtered by the custom filter function", async () => {
    const filter = (name) => name.includes("spec");
    const paths = await _chunkTPUVIKMVcjs.filesAsync.call(void 0, { basePath: __dirname, filter });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.length).toBeGreaterThan(0);
    expect(typeof paths[0]).toBe("string");
    expect(paths.every((path) => path.includes("spec"))).toBe(true);
  });
  it("should return an empty array if no files pass the custom filter function", async () => {
    const filter = (name) => name.includes("xyz");
    const paths = await _chunkTPUVIKMVcjs.filesAsync.call(void 0, { basePath: __dirname, filter });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.length).toBe(0);
  });
  it("should ignore hidden files by default", async () => {
    const paths = await _chunkTPUVIKMVcjs.filesAsync.call(void 0, { basePath: __dirname });
    expect(Array.isArray(paths)).toBe(true);
    expect(paths.every((path) => !path.includes("/."))).toBe(true);
  });
});
//# sourceMappingURL=files-async.spec.cjs.map